#include "component_action_angle.h"

/* DEPENDENCIES: Physics, AnimationIdle */

/* Ticks action angle component. */
void
component_action_angle_tick(ComponentActionAngle* self, ECS* ecs)
{
	ComponentPhysics* physics;
	ComponentAnimationIdle* animationIdle;

	physics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->component.id);
	animationIdle = ecs_component_get(ecs, ECS_COMPONENT_ANIMATION_IDLE, self->component.id);

	if 
	(
		physics->angle >= 0.0f && physics->angle < PI_FOURTH 
	)
		animationIdle->baseIndex = 0;
	else if
	(
		physics->angle >= PI_FOURTH && physics->angle < PI_HALF
	)
		animationIdle->baseIndex = 2;
	else if
	(
		physics->angle >= PI_HALF && physics->angle < (PI_HALF + PI_FOURTH)
	)
		animationIdle->baseIndex = 4;
	else if
	(
		physics->angle >= (PI_HALF + PI_FOURTH) && physics->angle < PI
	)
		animationIdle->baseIndex = 6;
	else if
	(
		physics->angle >= -PI && physics->angle < -(PI_HALF + PI_FOURTH)
	)
		animationIdle->baseIndex = 8;
	else if
	(
		physics->angle >= -(PI_HALF + PI_FOURTH) && physics->angle < -PI_HALF
	)
		animationIdle->baseIndex = 10;
	else if
	(
		physics->angle >= -PI_HALF && physics->angle < -PI_FOURTH
	)
		animationIdle->baseIndex = 12;
	else if
	(
		physics->angle >= -PI_FOURTH && physics->angle < 0.0f
	)
		animationIdle->baseIndex = 14;
}
