#include "component_action_delete_on_heart.h"

/* DEPENDENCIES: Heart */
/* This entity associated with this component will be deleted if the heart component is used. */

/* Initializes action delete on heart component. */
void
component_action_delete_on_heart_init(ComponentActionDeleteOnHeart* self, u32 heartID)
{
	self->heartID = heartID;
}

/* Ticks action delete on heart component. */
void
component_action_delete_on_heart_tick(ComponentActionDeleteOnHeart* self, ECS* ecs)
{
	ComponentHeart* heart;

	heart = ecs_component_get(ecs, ECS_COMPONENT_HEART, self->heartID);

	if (heart->uses > 0)
		ecs_entity_delete(ecs, self->component.id);
}
