#pragma once

#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_sprite.h"

#define COMPONENT_ACTION_FOLLOW_Z_OFFSET -0.01f

typedef struct ComponentActionFollow
{
	ECSComponent component;
	u32 followID;
	f32 offset;
} ComponentActionFollow;

void component_action_follow_tick(ComponentActionFollow* self, ECS* ecs);
void component_action_follow_init(ComponentActionFollow* self, u32 followID, f32 offset);

static const ECSComponentInfo COMPONENT_ACTION_FOLLOW_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL, 
			(ECSFunction)component_action_follow_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_ACTION_FOLLOW,
	.size = sizeof(ComponentActionFollow)
};


