#pragma once

#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_game_object.h"
#include "../stat/component_health.h"
#include "component_action_damage.h"

typedef struct ComponentActionOnHeightDamageDisable
{
	ECSComponent component;
	f32 height;
	bool isGrounded;
	bool isGroundedPrevious;
} ComponentActionOnHeightDamageDisable;

void component_action_on_height_damage_disable_init(ComponentActionOnHeightDamageDisable* self, f32 height);
void component_action_on_height_damage_disable_tick(ComponentActionOnHeightDamageDisable* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ACTION_ON_HEIGHT_DAMAGE_DISABLE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_action_on_height_damage_disable_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_ACTION_ON_HEIGHT_DAMAGE_DISABLE,
	.size = sizeof(ComponentActionOnHeightDamageDisable)
};


