#pragma once

#include "../stat/component_game_entity_type.h"
#include "../component_circle_collision.h"
#include "../component_physics.h"

typedef struct ComponentActionOnRadiusHone
{
	ECSComponent component;
	f32 speed;
	f32 multiplier;
	GameEntityType type;
	u32 targetID;
	u32 timer;
	bool isHoming;
} ComponentActionOnRadiusHone;

void
component_action_on_radius_hone_init
(
	ComponentActionOnRadiusHone* self, 
	f32 speed,
	f32 multiplier,
	GameEntityType type
);


void component_action_on_radius_hone_tick(ComponentActionOnRadiusHone* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ACTION_ON_RADIUS_HONE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_action_on_radius_hone_tick, 
			NULL
		}
	},
	.type = ECS_COMPONENT_ACTION_ON_RADIUS_HONE,
	.size = sizeof(ComponentActionOnRadiusHone)
};


