#pragma once

#include "ANIMATION_COMMON.h"
#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_sprite.h"
#include "../component_text.h"

typedef struct ComponentAnimationSquash
{
	ECSComponent component;
	f32 base;
	f32 multiplier;
	f32 speed;
	u32 timer;
} ComponentAnimationSquash;

void component_animation_squash_init(ComponentAnimationSquash* self, f32 base, f32 multiplier, f32 speed);
void component_animation_squash_tick(ComponentAnimationSquash* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ANIMATION_SQUASH_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL, 
			(ECSFunction)component_animation_squash_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_ANIMATION_SQUASH,
	.size = sizeof(ComponentAnimationSquash)
};
