#include "entity_state_fade.h"

/* Initializes a state_fade entity. */
void
entity_state_fade_init(ECS* ecs, u32 id, bool isFadeIn)
{
	ComponentSprite* sprite;
	ComponentAnimationColorChange* animationColorChange;
	
	sprite = ecs_component_add(ecs, ECS_COMPONENT_SPRITE, id);
	animationColorChange = ecs_component_add(ecs, ECS_COMPONENT_ANIMATION_COLOR_CHANGE, id);

	component_sprite_init
	(
		sprite,
		ecs->game->resources.textures[TEXTURE_STATE_FADE],
		(f32*)STATE_FADE_SIZE,
		(f32*)STATE_FADE_POSITION
	);

	if (isFadeIn)
	{
		component_animation_color_change_init
		(
			animationColorChange,
			(f32*)COLOR_TRANSPARENT,
			(f32*)COLOR_OPAQUE,
			STATE_FADE_TIMER,
			ANIMATION_COLOR_CHANGE_MODE_STICK
		);

		glm_vec4_copy((f32*)COLOR_OPAQUE, sprite->color);
	}
	else
	{
		component_animation_color_change_init
		(
			animationColorChange,
			(f32*)COLOR_OPAQUE,
			(f32*)COLOR_TRANSPARENT,
			STATE_FADE_TIMER,
			ANIMATION_COLOR_CHANGE_MODE_STICK
		);

		glm_vec4_copy((f32*)COLOR_TRANSPARENT, sprite->color);
	}
}
