#pragma once

#include "play/PLAY_COMMON.h"
#include "title/TITLE_COMMON.h"
#include "game_over/GAME_OVER_COMMON.h"
#include "results/RESULTS_COMMON.h"

#define STATE_COUNT STATE_RESULTS + 1
typedef enum StateType
{
	STATE_PLAY,
	STATE_TITLE,
	STATE_GAME_OVER,
	STATE_RESULTS
} StateType;

typedef struct Game Game;

typedef struct State
{
	Game* game;
	StateType type;
	StateType setType;
	bool isChanging;
	u32 fadeID;
	union
	{
		Play play;
		Title title;
		GameOver gameOver;
		Results results;
	} states;
} State;
