#pragma once

#include "../STATE_COMMON.h"

#include "../../ecs/ecs.h"

#include "../../ecs/entity/entity_cursor.h"
#include "../../ecs/entity/entity_sprite.h"
#include "../../ecs/entity/entity_menu_button.h"

static const vec2 RESULTS_BACKGROUND_SIZE = {1920.0f, 1080.0f};
static const vec3 RESULTS_BACKGROUND_POSITION = {960.0f, 540.0f, 0.2f};
static const vec3 RESULTS_MENU_BUTTON_POSITION = {960.0f, 800.0f, 0.1f};
static const vec3 RESULTS_TEXT_POSITION = {100.0f, 500.0f, 0.1f};

#define RESULTS_SHADER_COUNT 2
static const ShaderType RESULTS_SHADERS[RESULTS_SHADER_COUNT] =
{
	SHADER_TEXTURE_QUAD,
	SHADER_COLOR_QUAD
};

#define RESULTS_TEXTURE_COUNT 2
static const TextureType RESULTS_TEXTURES[RESULTS_TEXTURE_COUNT] =
{
	TEXTURE_STATE_FADE,
	TEXTURE_MENU_BUTTONS
};

#define RESULTS_FONT_COUNT 1
static const FontType RESULTS_FONTS[RESULTS_FONT_COUNT] =
{
	FONT_SMALL
};

#define RESULTS_SOUND_COUNT 1
static const SoundType RESULTS_SOUNDS[RESULTS_SOUND_COUNT] = 
{
	SOUND_SELECT
};

#define RESULTS_MUSIC_COUNT 1
static const MusicType RESULTS_MUSIC[RESULTS_MUSIC_COUNT] =
{
	MUSIC_RESULTS
};

void results_init(Results* self, State* state);
void results_tick(Results* self);
