#pragma once

#include "../STATE_COMMON.h"

#include "../../ecs/ecs.h"

#include "../../ecs/entity/entity_cursor.h"
#include "../../ecs/entity/entity_text.h"
#include "../../ecs/entity/entity_sprite.h"
#include "../../ecs/entity/entity_menu_button.h"

static const vec2 TITLE_LOGO_SIZE = {1024.0f, 512.0f};
static const vec3 TITLE_LOGO_POSITION = {960.0f, 400.0f, 0.1f};
static const vec3 TITLE_MENU_BUTTON_POSITION = {960.0f, 800.0f, 0.1f};
static const vec3 TITLE_CREDITS_POSITION = {32.0f, 32.0f, 0.1f};

#define TITLE_SHADER_COUNT 2
static const ShaderType TITLE_SHADERS[TITLE_SHADER_COUNT] =
{
	SHADER_TEXTURE_QUAD,
	SHADER_COLOR_QUAD
};

#define TITLE_TEXTURE_COUNT 4
static const TextureType TITLE_TEXTURES[TITLE_TEXTURE_COUNT] =
{
	TEXTURE_STATE_FADE,
	TEXTURE_CURSOR,
	TEXTURE_MENU_BUTTONS,
	TEXTURE_LOGO
};

#define TITLE_FONT_COUNT 1
static const FontType TITLE_FONTS[TITLE_FONT_COUNT] =
{
	FONT_CREDITS
};

#define TITLE_SOUND_COUNT 1
static const SoundType TITLE_SOUNDS[TITLE_SOUND_COUNT] = 
{
	SOUND_SELECT
};

#define TITLE_MUSIC_COUNT 1
static const MusicType TITLE_MUSIC[TITLE_MUSIC_COUNT] =
{
	MUSIC_TITLE
};

void title_init(Title* self, State* state);
void title_tick(Title* self);
